#ifndef dc__window_h
#define dc__window_h

#include <xcb/xcb.h>
#include <glib.h>

struct d_screen;

#define WINDOW_OPACITY_MAX 100
#define WINDOW_OPACITY_MIN 0

typedef struct d_window {
    xcb_window_t     id;
    struct d_screen *sc;
} d_window_t;

d_window_t* window_new(xcb_window_t id, struct d_screen *sc);

void window_ref(d_window_t *w);
void window_unref(d_window_t *w);

void window_show(d_window_t *w);
void window_hide(d_window_t *w);

void window_become_zombie(d_window_t *w);

gboolean window_is_zombie(d_window_t *w);
gboolean window_is_input_only(d_window_t *w);
gboolean window_is_mapped(d_window_t *w);

void window_get_area(d_window_t *w, int *x, int *y, int *width, int *height);

xcb_pixmap_t window_get_pixmap(d_window_t *w);

#endif
